# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/pipeline/#customization
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Container Scanning customization: https://docs.gitlab.com/ee/user/application_security/container_scanning/#customizing-the-container-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
stages:
- test
- lint
sast:
  stage: test
include:
- template: Security/SAST.gitlab-ci.yml

default:
  image: python:latest
  cache:                      # Pip's cache doesn't store the python packages
    paths:                    # https://pip.pypa.io/en/stable/topics/caching/
      - .cache/pip
  before_script:
    - python -V               # Print out python version for debugging
    - pip install virtualenv
    - virtualenv venv
    - source venv/bin/activate

variables:  # Change pip's cache directory to be inside the project directory since we can only cache local items.
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# lint template
.lint-tmpl:
  script:
    - echo "Linting Python version $VERSION"
  parallel:
    matrix:
      - VERSION: ['3.9', '3.10' ]   # https://hub.docker.com/_/python

# Lint, using Ruff (Rust): https://docs.astral.sh/ruff/
lint-ruff:
  stage: lint
  extends: [.lint-tmpl]
  script:
    - pip install -r requirements.txt
    - ruff check .

pytest:
  stage: test
  script:
    - pip install -r requirements.txt
    - pytest -vv -x